//       
//         
//         
//       
//  
//   
//           
//           
//            
//    ,         
//    .        
//      .      
// .           
//    ,  .    . 
#include <Trade\SymbolInfo.mqh>//      
#include <\\MyClass\Genetica_v1_0.mqh>
#include <\\MyClass\ClassLinearRegression.mqh>
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1
//--- plot CumIkviti
#property indicator_label1  "CumIkviti"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- input parameters
input string   Symb1="EURUSD";
input string   Symb2="GBPUSD";
input string   Symb3="USDCHF";
input string   Symb4="NONE";
input string   Symb5="NONE";
input string   Symb6="NONE";
input string   Symb7="NONE";
input string   Symb8="NONE";
input string   Symb9="NONE";
input string   Symb10="NONE";
double   CumIkvitiBuffer[];// 
//double   cumikviti[];//  
datetime oldstart;//    
datetime oldstop;//    
bool  objdrag;//    
bool  dragen;//    
struct sInstrum
  {//  
   string   Name;// 
   datetime start;//    
   datetime stop;//     
   double   ikviti[];//  
   double   open[];//       
   double   k;//    
   double   cost;//     
   double   startopen;//         
  };
MqlRates rates[];
sInstrum  Instrum[];//  
//CChartObjectVLine line;
CSymbolInfo symb;
CGen  genenica ;
CLinReg LinReg ;
//================================================================================
int OnInit()
  {
   objdrag=false ;
   dragen=true;
   CopyRates(Symbol(),Period(),1,1,rates) ;//    
   oldstop=rates[0].time;// 
   ObjectCreate(0,"Stop",OBJ_VLINE,0,oldstop,0) ; //     
   ObjectSetInteger(0,"Stop",OBJPROP_COLOR,Red) ;//     
   ObjectSetInteger(0,"Stop",OBJPROP_SELECTABLE,true) ;
   //------------------------------------------------------
   CopyRates(Symbol(),Period(),60,1,rates);//  20-  
   oldstart=rates[0].time;// 
   ObjectCreate(0,"Start",OBJ_VLINE,0,oldstart,0) ; 
   ObjectSetInteger(0,"Start",OBJPROP_COLOR,Green) ;
   ObjectSetInteger(0,"Start",OBJPROP_SELECTABLE,true) ;
   //------------------------------------------------------------
   SetIndexBuffer(0,CumIkvitiBuffer,INDICATOR_DATA);
   ArraySetAsSeries(CumIkvitiBuffer,true);
   //    
   int razm=0;//
   if(Symb1 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb1 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb1) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb1,0,oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
         //Print("    ",Instrum[razm-1].Name,"=  ",Instrum[razm-1].cost) ;
      } 
    if(Symb2 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb2 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb2) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb2,Period(),oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
         //Print("    ",Instrum[razm-1].Name,"=  ",Instrum[razm-1].cost) ;
      } 
    if(Symb3 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb3 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb3) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb3,Period(),oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
         //Print("    ",Instrum[razm-1].Name,"=  ",Instrum[razm-1].cost) ;
      }
    if(Symb4 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb4 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb4) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb4,Period(),oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
         //Print("    ",Instrum[razm-1].Name,"=  ",Instrum[razm-1].cost) ;
      }
    if(Symb5 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb5 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb5) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb5,Period(),oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
         //Print("    ",Instrum[razm-1].Name,"=  ",Instrum[razm-1].cost) ;
      }
    if(Symb6 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb6 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb6) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb6,Period(),oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
         //Print("    ",Instrum[razm-1].Name,"=  ",Instrum[razm-1].cost) ;
      }
    if(Symb7 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb7 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb7) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb7,Period(),oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
         //Print("    ",Instrum[razm-1].Name,"=  ",Instrum[razm-1].cost) ;
      }
    if(Symb8 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb8 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb8) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb8,Period(),oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
         //Print("    ",Instrum[razm-1].Name,"=  ",Instrum[razm-1].cost) ;
      }
    if(Symb9 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb9 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb9) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb9,Period(),oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
         //Print("    ",Instrum[razm-1].Name,"=  ",Instrum[razm-1].cost) ;
      }
    if(Symb10 !="NONE")
      {//   
         razm++ ;
         ArrayResize(Instrum,razm,0) ;// 
         Instrum[razm-1].Name=Symb10 ;Instrum[razm-1].stop=oldstop ;
         Instrum[razm-1].start=oldstart ; Instrum[razm-1].k=1 ;
         symb.Name(Symb10) ; Instrum[razm-1].cost=symb.TickValue() ;
         CopyRates(Symb10,Period(),oldstart,1,rates);//      
         Instrum[razm-1].startopen=rates[0].open ;
         //Print("    ",Instrum[razm-1].Name,"=  ",Instrum[razm-1].cost) ;
      }
      objdrag=true ;        
   return(0);
  }
//=================================================================================
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {//        
      datetime aaa;
      if( id == CHARTEVENT_OBJECT_DRAG && objdrag)
         {
            if (sparam == "Stop")
               {//             
                  //Print("     =============================") ;
                  aaa=oldstop-oldstart ;//   
                  oldstop=(datetime)ObjectGetInteger(0,"Stop",OBJPROP_TIME,0) ;
                  oldstart=oldstop-aaa ;
                  ObjectDelete(0,"Start") ;
                  ObjectCreate(0,"Start",OBJ_VLINE,0,oldstart,0) ; 
                  ObjectSetInteger(0,"Start",OBJPROP_COLOR,Green) ;
                  ObjectSetInteger(0,"Start",OBJPROP_SELECTABLE,true) ;
               }
            oldstart=(datetime)ObjectGetInteger(0,"Start",OBJPROP_TIME,0) ;
            //Print("    ========");
            dragen=true ;
         }
  }
//================================================================================
bool  Initialize()
   {//     
   //static bool first=true;//    
   int i,nambeval,nambeopen;
   double   openprice[];//     
   bool  flagnambopen;
      //           
         dragen=false; //first=false;
         //Print("   =====================") ;
         i=0 ;
         nambeval=ArraySize(Instrum);//     
         for(i=0;i<nambeval;i++)
           {
               ArrayResize(Instrum[i].ikviti,0,0) ;
               ArrayResize(Instrum[i].open,0,0);//        
           }
         flagnambopen=true ;
         for( i=0;i<nambeval;i++)
           {//      
              //if(CopyRates(Instrum[i].Name,Period(),oldstop,oldstart,rates) <= 0)
                //{ Print("    ",Instrum[i].Name); return(false) ;}
              if(!RatesCopy(i))
               { Print("    ",Instrum[i].Name); return(false) ;}
              if(flagnambopen)
               {//             
                  nambeopen=ArraySize(rates) ;
                  flagnambopen=false ;
               }
              if(nambeopen != ArraySize(rates))
               {//             
                  Print("      ",Instrum[i].Name,"        ") ;
                  return(false) ;
               }
              ArrayResize(Instrum[i].open,nambeopen,0);//      
               for(int j=0 ;j<nambeopen;j++)
                  {//   .
                     Instrum[i].open[j]=rates[j].open ;
                     //Instrum[i].startopen=rates[j] ;//         
                  }
               //double aaa=rates[nambeopen-1];
              Instrum[i].startopen=rates[0].open ;//         
              //Print("  ",Instrum[i].Name,"      =  ",nambeopen );
              //Print("    = ",Instrum[i].startopen,"   ",Instrum[i].Name);
           }
           return(true) ;
   }
//=================================================================================================================
bool  RatesCopy(int index)
   {//             
      int cnt=0;//      cnt>10     
         do
           {
            if(CopyRates(Instrum[index].Name,Period(),oldstop,oldstart,rates) > 0)
               {//    
                  return(true) ;
               }
            cnt++;Sleep(500) ;//      
           }
         while(cnt<100);
         //Print("   ",Instrum[index].Name,"  ",cnt,"  ");
      return(false) ;
   }
//=================================================================================================================
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   static bool first=true;//    
   int i,j;
   int nambeval=ArraySize(Instrum) ;
   bool reoptim;
   if(dragen || first)  
      {//        
         first=false ;
         if( !Initialize()) return(0) ;
         Optimization() ;
         for(i=0 ;i<nambeval;i++)
            {
               //Print("     ",Instrum[i].Name," = ",Instrum[i].k) ;
            }
         reoptim=true ;//     
      }
   ArraySetAsSeries(time,true);ArraySetAsSeries(open,true);ArraySetAsSeries(high,true);ArraySetAsSeries(low,true);
   ArraySetAsSeries(close,true);ArraySetAsSeries(tick_volume,true);ArraySetAsSeries(volume,true);ArraySetAsSeries(spread,true);
   CopyRates(Instrum[0].Name,Period(),time[0],oldstart,rates) ;
   int nambbar=ArraySize(rates) ;
   
   int total ;//   
   int hist=200+nambbar ;//     
   //if( PeriodSredn+1 >= rates_total ) {Print("    ") ; return(rates_total) ;}
   if(prev_calculated == 0 || reoptim)total=rates_total ;
   else  total=rates_total-prev_calculated+1 ;
   if( total > hist) total=hist ;
   int nambval=ArraySize(Instrum);//     
   double   cum=0 ;
   reoptim=false ;
   for(i=total;i>=0;i--)
      {//       
         cum=0;
         for(j=0;j<nambval;j++)
            {
               CopyRates(Instrum[j].Name,Period(),i,1,rates) ;
               cum=cum+(Instrum[j].startopen-rates[0].open)*Instrum[j].k*Instrum[j].cost;
            }
         //Print("  ",cum) ;
         CumIkvitiBuffer[i]=cum ;
      }
      
   return(rates_total);
  }
//===================================================================================================================
void OnDeinit(const int reason)
        {
            //Print("   ");
            ObjectDelete(0,"Start") ;
            ObjectDelete(0,"Stop") ;
        }
//===================================================================================================================
void  Optimization()
   {//       
      Print("  ================");
      int nambeval=ArraySize(Instrum) ;//      
      double   outmass[];//       
      ArrayResize(outmass,nambeval,0) ;
      double   rezmass[];//       
      ArrayResize(rezmass,nambeval+1,0) ;
      int i ;
      genenica.ResetCromosome() ;
      for(i=0 ;i< nambeval;i++)
         {//    
            genenica.AddOptimValue(-1,1) ;
         }
      genenica.Initialization() ;
      genenica.SetDirConverg(1);
      genenica.AccuracyCalculate(50,50);    
      do  //      
      {
         genenica.Start();//         
         genenica.SetParamFF(outmass) ;//         FF 
         for( i=0; i< nambeval ;i++)
            {//        
               Instrum[i].k=outmass[i] ;
               //Print("  ",Instrum[i].Name,"  =  ",outmass[i]) ;
            }
         double y=CumIdealIkviti();
         //Print("   = ",y);
         genenica.GetParamFF(y) ;//            
      }
   while(!genenica.Ended());//          ,        
                        //    
      Print("  ===============");
      genenica.SetRambo(rezmass) ;
      
      //Print("   = ",NormalizeDouble(rezmass[4],3),"   ",Instrum[0].Name,"= ",NormalizeDouble(rezmass[0],3),
      //"   ",Instrum[1].Name,"= ",NormalizeDouble(rezmass[1],3),"   ",Instrum[2].Name,"= ",NormalizeDouble(rezmass[2],3),
       //"   ",Instrum[3].Name,"= ",NormalizeDouble(rezmass[3],3)) ;
       
       
      for( i=0; i< nambeval ;i++)
            {//        
               Instrum[i].k=rezmass[i] ;
               Print("  ",Instrum[i].Name,"  =  ",outmass[i]) ;
            } 
      return ;
   }
//======================================================================================================================
double   CumIdealIkviti()
   {//            .
    //             
    //            
    //              
    //     
    int  nambeopen=ArraySize(Instrum[0].open) ;//-   
    int nambeval=ArraySize(Instrum) ;//    
    int  i,j ;//  
    double  cumikviti[];
    ArrayResize(cumikviti,nambeopen) ;
    ArrayInitialize(cumikviti,0) ;
    for(i=0;i<nambeval;i++)
      {//     
         ArrayResize(Instrum[i].ikviti,nambeopen) ;//    
         for(j=0;j<nambeopen;j++)
            {//         
               Instrum[i].ikviti[j]=(Instrum[i].open[j]-Instrum[i].startopen)*Instrum[i].k*Instrum[i].cost ;
               cumikviti[j]=cumikviti[j]+Instrum[i].ikviti[j];
               //Print("   = ",cumikviti[j]);
            }
          //Print("    = ",Instrum[i].ikviti[nambeopen-1],"     ",Instrum[i].Name);
          //Print("   = ",Instrum[i].k,"    ",Instrum[i].Name) ;
      }
    double  ugol=LinReg.getUgol(cumikviti) ;
    double  hitrdisp=LinReg.getHitrDisp(cumikviti) ;
    double  y=ugol/hitrdisp ;//        .
    //Print("    = ",ugol);
    //Print("   = ",hitrdisp); 
    //Print("  = ",y);
      return(y) ;
   }